﻿@using PhotinoNET
@using DayZLegacy.Services
@using Shared
@using DayZLegacy.Components
@inherits LayoutComponentBase
@implements IDisposable

<div class="main" @onmousedown=@HandleDragStart 
                         @onmousemove=@HandleDrag 
                         @onmouseup="@HandleDragEnd"
     @onmouseleave="@HandleDragEnd">
    <div class="top-btns p-2 d-flex justify-content-end">
        <button tabindex="-1" class="oi oi-minus bg-transparent border-0 text-white" @onclick="@(() => Window.SetMinimized(true))" />
        <button tabindex="-1" class="oi oi-x bg-transparent border-0 text-white" style="top:0" @onclick="@Window.Close" />
    </div>
    
    <div class="px-0 content">
        @Body
        @if (AlertService.Alert is not null)
        {
            <div class="bottom-0 left-0 position-absolute w-100 bg-danger d-flex justify-content-between align-items-center system-text font-size-14px p-1">
                <div class="ml-3 w-75">
                    <span>
                        @AlertService.Alert.Message
                    </span>
                </div>
                <Button ButtonText="X" 
                        OnClick="@(async () => await AlertService.HideAsync(true))" 
                        ClassName="hover-disabled" />
            </div>
        }
    </div>
</div>

<div id="video-wrapper" class="w-100 h-100 position-absolute overflow-hidden text-center align-items-center d-flex justify-content-center">
</div>

@code {
    [Inject]
    private PhotinoWindow Window { get; set; } = default!;

    [Inject] 
    private IJSRuntime JSRuntime { get; set; } = default!;
    
    [Inject]
    private LauncherService LauncherService { get; set; } = default!;
    
    [Inject]
    private ConfigService ConfigService { get; set; } = default!;
    
    [Inject]
    private AlertService AlertService { get; set; } = default!;
    
    private bool isDragging;

    protected override void OnInitialized()
    {
        LauncherService.OnBackgroundChanged += HandleBackgroundChanged;
        AlertService.OnAlert += StateHasChanged;
    }

    protected override void OnAfterRender(bool firstRender)
    {
        if (firstRender)
        {
            HandleBackgroundChanged();
        }
    }

    private void HandleBackgroundChanged()
    {
        if (ConfigService.Settings.LauncherSettings.BackgroundMediaType.Contains("image"))
        {
            JSRuntime.InvokeVoidAsync("changeImageBackground", ConfigService.Settings.LauncherSettings.BackgroundMediaSrc)
                .AndForget();
        }
        else if (ConfigService.Settings.LauncherSettings.BackgroundMediaType.Contains("video"))
        {
            JSRuntime.InvokeVoidAsync("changeVideoBackground", ConfigService.Settings.LauncherSettings.BackgroundMediaSrc)
                .AndForget();
        }
    }
    
    public void Dispose()
    {
        LauncherService.OnBackgroundChanged -= HandleBackgroundChanged;
        AlertService.OnAlert -= StateHasChanged;
    }

    private void HandleDragStart(MouseEventArgs mouseEventArgs)
    {
        isDragging = true;
    }

    private void HandleDrag(MouseEventArgs mouseEventArgs)
    {
        if (isDragging)
        {
            const int minXOffsetPxThreshold = 15, minYOffsetPxThreshold = 5;
            
            var offsetX = (int)mouseEventArgs.MovementX;
            offsetX = Window.Location.X < minYOffsetPxThreshold && 
                      (int)mouseEventArgs.ScreenX < minYOffsetPxThreshold ? 0 : offsetX;
            
            var offsetY = (int)mouseEventArgs.MovementY;
            offsetY = Window.Location.Y < minXOffsetPxThreshold && 
                      (int)mouseEventArgs.ScreenY < minXOffsetPxThreshold ? 0 : offsetY;
            
            Window.Offset(offsetX, offsetY);
        }
    }
    
    private void HandleDragEnd(MouseEventArgs mouseEventArgs)
    {
        isDragging = false;
    }
}